Kea: isc::yang::TranslatorPdPools Class Reference

| Kea 3.2.0-git

isc::yang::TranslatorPdPools Class Reference

A translator class for converting a pd-pool list between YANG and JSON. More...

`#include <translator_pd_pool.h>`

Inheritance diagram for isc::yang::TranslatorPdPools:
[legend]

## Public Member Functions
| TranslatorPdPools (sysrepo::Session session, const std::string &model)
| Constructor.
virtual | ~TranslatorPdPools ()=default
| Destructor.
isc::data::ElementPtr | getPdPools (libyang::DataNode const &data_node)
| Translate pd-pools from YANG to JSON.
isc::data::ElementPtr | getPdPoolsFromAbsoluteXpath (std::string const &xpath)
| Translate pd-pools from YANG to JSON.
void | setPdPools (const std::string &xpath, isc::data::ConstElementPtr elem)
| Translate and set pd-pools from JSON to YANG.
Public Member Functions inherited from isc::yang::TranslatorPdPool
| TranslatorPdPool (sysrepo::Session session, const std::string &model)
| Constructor.
virtual | ~TranslatorPdPool ()=default
| Destructor.
isc::data::ElementPtr | getPdPool (libyang::DataNode const &data_node)
| Translate a pd-pool from YANG to JSON.
isc::data::ElementPtr | getPdPoolFromAbsoluteXpath (std::string const &xpath)
| Translate a pd-pool from YANG to JSON.
void | setPdPool (const std::string &xpath, isc::data::ConstElementPtr elem)
| Translate and set pd-pool from JSON to YANG.
Public Member Functions inherited from isc::yang::TranslatorOptionDataList
| TranslatorOptionDataList (sysrepo::Session session, const std::string &model)
| Constructor.
virtual | ~TranslatorOptionDataList ()=default
| Destructor.
isc::data::ConstElementPtr | getOptionDataList (libyang::DataNode const &data_node)
| Translate option data list from YANG to JSON.
isc::data::ConstElementPtr | getOptionDataListFromAbsoluteXpath (std::string const &xpath)
| Translate option data list from YANG to JSON.
void | setOptionDataList (const std::string &xpath, isc::data::ConstElementPtr elem)
| Translate and set option data list from JSON to YANG.
Public Member Functions inherited from isc::yang::TranslatorOptionData
| TranslatorOptionData (sysrepo::Session session, const std::string &model)
| Constructor.
virtual | ~TranslatorOptionData ()=default
| Destructor.
isc::data::ElementPtr | getOptionData (libyang::DataNode const &data_node)
| Translate an option data from YANG to JSON.
isc::data::ElementPtr | getOptionDataFromAbsoluteXpath (std::string const &xpath)
| Translate an option data from YANG to JSON.
void | setOptionData (const std::string &xpath, isc::data::ConstElementPtr elem)
| Translate and set option data from JSON to YANG.
Public Member Functions inherited from isc::yang::Translator
| Translator (sysrepo::Session session, const std::string &model)
| Constructor.
virtual | ~Translator ()=default
| Destructor.
template<typename T>
void | checkAndGet (isc::data::ElementPtr const &storage, libyang::DataNode const &data_node, std::string const &xpath, T translate) const
| Calls {translate} for the element found at {xpath} relative to {data_node} and sets the result in {storage} with the {xpath} key.
void | checkAndGetAndJsonifyLeaf (isc::data::ElementPtr &storage, libyang::DataNode const &data_node, const std::string &name) const
| Retrieves a child YANG data node identified by name from the given parent YANG container node, converts it from string to JSON and stores it in the specified storage.
template<typename T>
void | checkAndGetDiverging (isc::data::ElementPtr const &storage, libyang::DataNode const &data_node, std::string const &key, std::string const &xpath, T translate) const
| Calls {translate} for the element found at {xpath} relative to {data_node} and sets the result in {storage} with the {key} key.
void | checkAndGetDivergingLeaf (isc::data::ElementPtr &storage, libyang::DataNode const &data_node, std::string const &name, std::string const &yang_name) const
| Retrieves a child YANG data node identified by name from the given parent YANG container node and stores it in the specified storage.
void | checkAndGetLeaf (isc::data::ElementPtr &storage, libyang::DataNode const &data_node, std::string const &name) const
| Retrieves a child YANG data node identified by name from the given parent YANG container node and stores it in the specified storage.
void | checkAndSetDivergingLeaf (isc::data::ConstElementPtr const &from, std::string const &xpath, std::string const &name, std::string const &yang_name, libyang::LeafBaseType const type)
| Get an element from given ElementPtr node and set it in sysrepo at given xpath.
void | checkAndSetLeaf (isc::data::ConstElementPtr const &from, std::string const &xpath, std::string const &name, libyang::LeafBaseType const type)
| Get an element from given ElementPtr node and set it in sysrepo at given xpath.
void | checkAndSetLeafList (isc::data::ConstElementPtr const &from, std::string const &xpath, std::string const &name, libyang::LeafBaseType const type)
| Get an element from given ElementPtr node and set it in sysrepo at given xpath as a leaf-list.
void | checkAndSetUserContext (isc::data::ConstElementPtr const &from, std::string const &xpath)
| Get an element from given ElementPtr node and set it in sysrepo at given xpath.
void | checkAndStringifyAndSetLeaf (isc::data::ConstElementPtr const &from, std::string const &xpath, std::string const &name)
| Get an element from given ElementPtr node and set it in sysrepo at given xpath.
void | deleteItem (const std::string &xpath)
| Delete basic value from YANG.
libyang::DataNode | findXPath (std::string const &xpath) const
| Retrieves a YANG data node by xpath.
template<typename functor_t>
void | forAll (std::string const &xpath, functor_t f) const
| Run a function for a node and all its children.
std::optional< libyang::DataNode > | getData (std::string const &xpath) const
| Get a YANG data node found at the given absolute xpath.
isc::data::ElementPtr | getItem (libyang::DataNode const &data_node, std::string const &xpath) const
| Translate a basic value from YANG to JSON for a given xpath that is relative to the given source node.
isc::data::ElementPtr | getItemFromAbsoluteXpath (std::string const &xpath) const
| Translate a basic value from YANG to JSON for a given absolute xpath.
template<typename T>
isc::data::ElementPtr | getList (libyang::DataNode const &data_node, std::string const &xpath, T &t, isc::data::ElementPtr(T::*f)(libyang::DataNode const &)) const
| Retrieve a list as ElementPtr from sysrepo from a certain xpath.
void | getMandatoryDivergingLeaf (isc::data::ElementPtr &storage, libyang::DataNode const &data_node, std::string const &name, std::string const &yang_name) const
| Retrieves a child YANG data node identified by one name from the given parent YANG container node and stores it in the specified storage under a different name.
void | getMandatoryLeaf (isc::data::ElementPtr &storage, libyang::DataNode const &data_node, std::string const &name) const
| Retrieves a child YANG data node identified by name from the given parent YANG container node and stores it in the specified storage.
bool | schemaNodeExists (std::string const &xpath) const
| Checks whether a YANG node exists in the schema.
void | setItem (const std::string &xpath, isc::data::ConstElementPtr const elem, libyang::LeafBaseType const type)
| Translate and set basic value from JSON to YANG.
void | setMandatoryDivergingLeaf (isc::data::ConstElementPtr const &from, std::string const &xpath, std::string const &name, std::string const &yang_name, libyang::LeafBaseType const type)
| Get an element from given ElementPtr node and set it in sysrepo at given xpath.
void | setMandatoryLeaf (isc::data::ConstElementPtr const &from, std::string const &xpath, std::string const &name, libyang::LeafBaseType const type)
| Get an element from given ElementPtr node and set it in sysrepo at given xpath.

## Protected Member Functions
isc::data::ElementPtr | getPdPoolsCommon (libyang::DataNode const &data_node)
| getPdPools common part.
void | setPdPoolsId (const std::string &xpath, isc::data::ConstElementPtr elem)
| setPdPools using pool-id.
void | setPdPoolsPrefix (const std::string &xpath, isc::data::ConstElementPtr elem)
| setPdPools using prefix.
Protected Member Functions inherited from isc::yang::TranslatorPdPool
isc::data::ElementPtr | getPdPoolIetf6 (libyang::DataNode const &data_node)
| getPdPool for ietf-dhcpv6-server.
isc::data::ElementPtr | getPdPoolKea (libyang::DataNode const &data_node)
| getPdPool for kea-dhcp6-server.
void | setPdPoolIetf6 (const std::string &xpath, isc::data::ConstElementPtr elem)
| setPdPool for ietf-dhcpv6-server.
void | setPdPoolKea (const std::string &xpath, isc::data::ConstElementPtr elem)
| setPdPool for kea-dhcp6-server.
Protected Member Functions inherited from isc::yang::TranslatorOptionDataList
isc::data::ConstElementPtr | getOptionDataListKea (libyang::DataNode const &data_node)
| getOptionDataList for kea-dhcp[46].
void | setOptionDataListKea (const std::string &xpath, isc::data::ConstElementPtr elem)
| setOptionDataList for kea-dhcp[46].
Protected Member Functions inherited from isc::yang::TranslatorOptionData
isc::data::ElementPtr | getOptionDataKea (libyang::DataNode const &data_node)
| getOptionData JSON for kea-dhcp[46].
void | setOptionDataKea (const std::string &xpath, isc::data::ConstElementPtr elem)
| setOptionData for kea-dhcp[46].

## Additional Inherited Members
Static Public Member Functions inherited from isc::yang::Translator
static isc::data::ElementPtr | translateFromYang (std::optional< libyang::DataNode > data_node)
| Translate basic value from the given YANG data node to JSON element.
static std::optional< std::string > | translateToYang (isc::data::ConstElementPtr const &elem, libyang::LeafBaseType const type)
| Translate basic value from JSON to YANG.
Protected Types inherited from isc::yang::Translator
using | Deserializer
| Maps YANG types to functions that transform a YANG type into an ElementPtr.
using | Serializer
| Maps YANG types to functions that transform the string representation of an Element into a string that can be passed into Session::setItem().
Static Protected Member Functions inherited from isc::yang::Translator
static std::string | decode64 (std::string const &input)
| Decode a YANG element of binary type to a string that can be stored in an Element::string JSON.
static std::string | encode64 (std::string const &input)
| Encode a string such that it can be stored in a YANG element of binary type.
static Deserializer | initializeDeserializer ()
| Initializes the deserializer which is used to translate a YANG node to an ElementPtr.
static Serializer | initializeSerializer ()
| Initializes the serializer which is used to translate the string value of an Element to a string that can be passed into Session::setItem().
Protected Attributes inherited from isc::yang::Translator
std::string | model_
| The model.
sysrepo::Session | session_
| The sysrepo session.

## Detailed Description

A translator class for converting a pd-pool list between YANG and JSON.

Currently supports the following models:

- kea-dhcp6-server
- ietf-dhcpv6-server (partial support)

Definition at line 199 of file translator_pd_pool.h.

## Constructor & Destructor Documentation

## ◆ TranslatorPdPools()

isc::yang::TranslatorPdPools::TranslatorPdPools | ( | sysrepo::Session | session,
|  | const std::string & | model )

Constructor.

Parameters

  session | Sysrepo session.
  model | Model name.

Definition at line 269 of file translator_pd_pool.cc.

References isc::yang::TranslatorPdPool::TranslatorPdPool().

Referenced by isc::yang::TranslatorSubnet::TranslatorSubnet().

Here is the call graph for this function:

## ◆ ~TranslatorPdPools()

virtual isc::yang::TranslatorPdPools::~TranslatorPdPools | ( |  | ) |
| virtualdefault

Destructor.

## Member Function Documentation

## ◆ getPdPools()

ElementPtr isc::yang::TranslatorPdPools::getPdPools | ( | libyang::DataNode const & | data_node | ) |

Translate pd-pools from YANG to JSON.

Parameters

  data_node | the YANG node representing the list of PD pools

Returns
  the JSON representation of the list of PD pools

Exceptions

  NetconfError | when sysrepo raises an error.

Definition at line 277 of file translator_pd_pool.cc.

References getPdPoolsCommon(), isc_throw, isc::yang::Translator::model_, and isc::Exception::what().

Referenced by getPdPoolsFromAbsoluteXpath(), isc::yang::TranslatorSubnet::getSubnetIetf6(), and isc::yang::TranslatorSubnet::getSubnetKea().

Here is the call graph for this function:

## ◆ getPdPoolsCommon()

ElementPtr isc::yang::TranslatorPdPools::getPdPoolsCommon | ( | libyang::DataNode const & | data_node | ) |
| protected

getPdPools common part.

Parameters

  data_node | the YANG node representing the list of PD pools

Exceptions

  NetconfError | when sysrepo raises an error.

Definition at line 302 of file translator_pd_pool.cc.

References isc::yang::Translator::getList(), and isc::yang::TranslatorPdPool::getPdPool().

Referenced by getPdPools().

Here is the call graph for this function:

## ◆ getPdPoolsFromAbsoluteXpath()

ElementPtr isc::yang::TranslatorPdPools::getPdPoolsFromAbsoluteXpath | ( | std::string const & | xpath | ) |

Translate pd-pools from YANG to JSON.

Parameters

  xpath | The xpath of the pd-pool list.

Returns
  the JSON representation of the list of PD pools

Exceptions

  NetconfError | when sysrepo raises an error.

Definition at line 293 of file translator_pd_pool.cc.

References isc::yang::Translator::findXPath(), and getPdPools().

Here is the call graph for this function:

## ◆ setPdPools()

void isc::yang::TranslatorPdPools::setPdPools | ( | const std::string & | xpath,
|  | isc::data::ConstElementPtr | elem )

Translate and set pd-pools from JSON to YANG.

Parameters

  xpath | The xpath of the pd-pool list.
  elem | The JSON element.

Definition at line 308 of file translator_pd_pool.cc.

References isc_throw, isc::yang::Translator::model_, setPdPoolsId(), setPdPoolsPrefix(), and isc::Exception::what().

Referenced by isc::yang::TranslatorSubnet::setSubnetIetf6(), and isc::yang::TranslatorSubnet::setSubnetKea().

Here is the call graph for this function:

## ◆ setPdPoolsId()

void isc::yang::TranslatorPdPools::setPdPoolsId | ( | const std::string & | xpath,
|  | isc::data::ConstElementPtr | elem )
| protected

setPdPools using pool-id.

Parameters

  xpath | The xpath of the pd-pool list.
  elem | The JSON element.

Definition at line 326 of file translator_pd_pool.cc.

References isc::yang::TranslatorPdPool::setPdPool().

Referenced by setPdPools().

Here is the call graph for this function:

## ◆ setPdPoolsPrefix()

void isc::yang::TranslatorPdPools::setPdPoolsPrefix | ( | const std::string & | xpath,
|  | isc::data::ConstElementPtr | elem )
| protected

setPdPools using prefix.

Parameters

  xpath | The xpath of the pd-pool list.
  elem | The JSON element.

Exceptions

  BadValue | on pd-pool without prefix or prefix length.

Definition at line 336 of file translator_pd_pool.cc.

References isc_throw, and isc::yang::TranslatorPdPool::setPdPool().

Referenced by setPdPools().

Here is the call graph for this function:

The documentation for this class was generated from the following files:

- translator_pd_pool.h
- translator_pd_pool.cc